// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'information_matrix'
#include "std_msgs/msg/detail/float64_multi_array__struct.hpp"
// Member 'measurement_transform'
#include "geometry_msgs/msg/detail/transform__struct.hpp"
// Member 'attributes'
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Edge __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Edge __declspec(deprecated)
#endif

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Edge_
{
  using Type = Edge_<ContainerAllocator>;

  explicit Edge_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : information_matrix(_init),
    measurement_transform(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->origin_node = 0ll;
      this->target_node = 0ll;
      this->edge_id = 0ll;
      std::fill<typename std::array<double, 4>::iterator, double>(this->plane_coefficients.begin(), this->plane_coefficients.end(), 0.0);
      std::fill<typename std::array<double, 9>::iterator, double>(this->plane_information_matrix.begin(), this->plane_information_matrix.end(), 0.0);
    }
  }

  explicit Edge_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : plane_coefficients(_alloc),
    plane_information_matrix(_alloc),
    information_matrix(_alloc, _init),
    measurement_transform(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->origin_node = 0ll;
      this->target_node = 0ll;
      this->edge_id = 0ll;
      std::fill<typename std::array<double, 4>::iterator, double>(this->plane_coefficients.begin(), this->plane_coefficients.end(), 0.0);
      std::fill<typename std::array<double, 9>::iterator, double>(this->plane_information_matrix.begin(), this->plane_information_matrix.end(), 0.0);
    }
  }

  // field types and members
  using _origin_node_type =
    int64_t;
  _origin_node_type origin_node;
  using _target_node_type =
    int64_t;
  _target_node_type target_node;
  using _edge_id_type =
    int64_t;
  _edge_id_type edge_id;
  using _plane_coefficients_type =
    std::array<double, 4>;
  _plane_coefficients_type plane_coefficients;
  using _plane_information_matrix_type =
    std::array<double, 9>;
  _plane_information_matrix_type plane_information_matrix;
  using _information_matrix_type =
    std_msgs::msg::Float64MultiArray_<ContainerAllocator>;
  _information_matrix_type information_matrix;
  using _measurement_transform_type =
    geometry_msgs::msg::Transform_<ContainerAllocator>;
  _measurement_transform_type measurement_transform;
  using _attributes_type =
    std::vector<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>>;
  _attributes_type attributes;

  // setters for named parameter idiom
  Type & set__origin_node(
    const int64_t & _arg)
  {
    this->origin_node = _arg;
    return *this;
  }
  Type & set__target_node(
    const int64_t & _arg)
  {
    this->target_node = _arg;
    return *this;
  }
  Type & set__edge_id(
    const int64_t & _arg)
  {
    this->edge_id = _arg;
    return *this;
  }
  Type & set__plane_coefficients(
    const std::array<double, 4> & _arg)
  {
    this->plane_coefficients = _arg;
    return *this;
  }
  Type & set__plane_information_matrix(
    const std::array<double, 9> & _arg)
  {
    this->plane_information_matrix = _arg;
    return *this;
  }
  Type & set__information_matrix(
    const std_msgs::msg::Float64MultiArray_<ContainerAllocator> & _arg)
  {
    this->information_matrix = _arg;
    return *this;
  }
  Type & set__measurement_transform(
    const geometry_msgs::msg::Transform_<ContainerAllocator> & _arg)
  {
    this->measurement_transform = _arg;
    return *this;
  }
  Type & set__attributes(
    const std::vector<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>> & _arg)
  {
    this->attributes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Edge
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Edge
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Edge_ & other) const
  {
    if (this->origin_node != other.origin_node) {
      return false;
    }
    if (this->target_node != other.target_node) {
      return false;
    }
    if (this->edge_id != other.edge_id) {
      return false;
    }
    if (this->plane_coefficients != other.plane_coefficients) {
      return false;
    }
    if (this->plane_information_matrix != other.plane_information_matrix) {
      return false;
    }
    if (this->information_matrix != other.information_matrix) {
      return false;
    }
    if (this->measurement_transform != other.measurement_transform) {
      return false;
    }
    if (this->attributes != other.attributes) {
      return false;
    }
    return true;
  }
  bool operator!=(const Edge_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Edge_

// alias to use template instance with default allocator
using Edge =
  situational_graphs_reasoning_msgs::msg::Edge_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__STRUCT_HPP_
